Attribute VB_Name = "MapEdLst"
Option Explicit

Public Type FileFormatA
            LineID As String * 7
            ArtibCodeMin As String * 2
            NumPts As String * 6
            AtribCodeMaj As String * 5
End Type
Public Record1 As FileFormatA

Public Type FileFormatB
            LatDeg As String * 2
            LatMinute As String * 2
            LatSec As String * 2
            LatHemi As String * 1
            LonDeg As String * 3
            LonMinute As String * 2
            LonSec As String * 2
            LonHemi As String * 1
            SeqCount As String * 5
End Type
Public Record2 As FileFormatB

Public Type FileFormatC
            fRangeRecNum As String * 13 'First 12 records in file. One record for each
            rNumOfMaps As String * 10   'map range from 2048 to 1 mile map range
End Type
Public MapListRange As FileFormatC

Public Type FileFormatD
            MapFileName As String * 8
            CenLatDeg As String * 2
            CenLatDec As String * 4
            CenLatHemi As String * 1
            CenLonDeg As String * 3
            CenLonDec As String * 4
            CenLonHemi As String * 1
End Type
Public MapListData As FileFormatD

Public Type StuffMap
            MapRange As Integer
            OldRange As Integer
            LatCen As Single
            LonCen As Single
            OldLatCen As Single
            OldLonCen As Single
            LatMax As Single
            LatMin As Single
            LonMax As Single
            LonMin As Single
            RangeY As Single
            RangeX As Single
End Type
Public MapParam As StuffMap

Public Type Apt
            x As Single
            Y As Single
End Type

Public AnchorPT As Apt


Public MouseDragFlag As Boolean
Public LoadFlag As Boolean
Public CopyMoveIndex As Integer

Public Sub ScaleMap()
Dim x As Integer
Dim Shold As String

EdMapLstFrm!Map1.Picture = LoadPicture()
EdMapLstFrm!Pic1.Picture = LoadPicture()


MapParam.RangeY = MapParam.MapRange / 60
MapParam.RangeX = 4 * MapParam.MapRange / (Cos(3.1416 * MapParam.LatCen / 180) * 3 * 60)
MapParam.LatMax = MapParam.LatCen + MapParam.RangeY
MapParam.LatMin = MapParam.LatCen - MapParam.RangeY
MapParam.LonMax = MapParam.LonCen + MapParam.RangeX
MapParam.LonMin = MapParam.LonCen - MapParam.RangeX
EdMapLstFrm!Map1.Scale (MapParam.LonMax, MapParam.LatMax)-(MapParam.LonMin, MapParam.LatMin)
EdMapLstFrm!Pic1.Scale (MapParam.LonMax, MapParam.LatMax)-(MapParam.LonMin, MapParam.LatMin)


End Sub

Public Function DrwDosMap(sFilepath As String) As String
Dim FileNumber As Integer
Dim FirstTime As Boolean
Dim InRecord
Dim LatMax As Single
Dim LonMax As Single
Dim Ppd As Long
Dim LatCen As Single
Dim LonCen As Single
Dim MapRadius As Integer
Dim MinRange As Integer
Dim MapType As String
Dim LatPoint As String
Dim LonPoint As String
Dim FeaColor As Integer
Dim I As Integer
Dim sBytes As String
Dim XYZ As String
Dim x As String
Dim Y As String
Dim z As String
Dim zx As Integer
Dim zy As Integer
Dim xx As Integer
Dim YY As Integer
Dim sini As String
Dim MapFileName As String

Dim LatDec As Single
Dim LonDec As Single
Dim LineColor As Long

FileNumber = FreeFile

sini = Dir(sFilepath)
If sini = "" Then
  DrwDosMap = ""
  Exit Function
End If

MapFileName = Right(sFilepath, 12)
If InStr(MapFileName, "\") <> 0 Then MapFileName = Mid(MapFileName, InStr(MapFileName, "\") + 1)
Open sFilepath For Input As FileNumber
Input #FileNumber, LatMax
Line Input #FileNumber, InRecord
Input #FileNumber, LonMax
Line Input #FileNumber, InRecord
Input #FileNumber, Ppd
Line Input #FileNumber, InRecord
Input #FileNumber, LatCen
Line Input #FileNumber, InRecord
Input #FileNumber, LonCen
Line Input #FileNumber, InRecord
Input #FileNumber, MapRadius
Line Input #FileNumber, InRecord
Input #FileNumber, MinRange
Line Input #FileNumber, InRecord
Input #FileNumber, MapType

If MapType <> "ASCII" And MapType <> "LineFormat" Then
  MsgBox "APRS-SCS will only work with ASCII and Line Format APRSdos maps. The type of this map is " & MapType & " Which is not supported.", vbInformation
  Close FileNumber
  DrwDosMap = ""
  Exit Function
End If

On Error GoTo HANDLELER

If MapType = "ASCII" Then
  Input #FileNumber, LonPoint, LatPoint
  Do
    If LonPoint = "0" And LatPoint = "0" Then
      FirstTime = True
      Input #FileNumber, FeaColor
      Line Input #FileNumber, InRecord
      Do
        Input #FileNumber, LonPoint, LatPoint
        If LonPoint = "0" And LatPoint = "-1" Then Exit Do
        If LonPoint <> "0" And LatPoint <> "0" Then
          LineColor = QBColor(FeaColor)
          LonDec = LonMax - (Val(LonPoint) / Ppd)
          LatDec = LatMax - (Val(LatPoint) / Ppd)
          GoSub PlotPoint
        End If
      Loop Until LonPoint = "0" And LatPoint = "0"
    End If
  Loop Until LonPoint = "0" And LatPoint = "-1"
Else
  Do
    Input #FileNumber, FeaColor
    If FeaColor = -1 Then Exit Do  'end of features data
    FirstTime = True
    Line Input #FileNumber, sBytes
        'at this point L$ contains a full feature of many 3 byte points
        'The next FOR-NEXT loop parses this L$ string 3 bytes at a time
    For I = 1 To Len(sBytes) Step 3
      'I = I + 1
      XYZ = Mid$(sBytes, I, 3) 'this gets each 3 bytes at a time
            'lets call each 3 bytes as XYZ (all printable 7 bit ascii)
            'where X is the MSBits of X and Y is the MSBits of Y
            'and Z contains the LSBits of both = .xxxxyyy
            'So the final value of Xx is 16*X + xxxx  and
            'the final value of Yy is 8*Y +yyy
      x = Left$(XYZ, 1)
      Y = Mid$(XYZ, 2, 1)
      z = Right$(XYZ, 1)  'extract the "Z" byte
            'Each of these bytes has been bumped up into printable
            'ASCII by having had 27 added to them during compression
      zx = Int((Asc(z) - 27) / 8) 'extracts the X portion of Z$
      zy = (Asc(z) - 27) - zx * 8 'extracts the Y portion of Z$
      xx = 16 * (Asc(x) - 27) + zx
      YY = 8 * (Asc(Y) - 27) + zy
            'at this point you have the same X,Y values of a normal DOSmap
      LineColor = QBColor(FeaColor)
      LonDec = LonMax - (xx / Ppd)
      LatDec = LatMax - (YY / Ppd)
      GoSub PlotPoint
    Next
  Loop
End If

Close FileNumber
EdMapLstFrm!Map1.Picture = EdMapLstFrm!Pic1.Image
DrwDosMap = "AOK"
Exit Function

PlotPoint:
              If FirstTime Then
                EdMapLstFrm!Map1.PSet (LonDec, LatDec), LineColor
                EdMapLstFrm!Pic1.PSet (LonDec, LatDec), LineColor
              Else
                EdMapLstFrm!Map1.Line -(LonDec, LatDec), LineColor
                EdMapLstFrm!Pic1.Line -(LonDec, LatDec), LineColor
              End If
              FirstTime = False
Return

Exit Function
HANDLELER:
           Close FileNumber
           MsgBox "A Dos map file error has occured. " & MapFileName & " Has an error. Please send an E-Mail to kb2scs@arrl.net letting me know the name of the map file so I can fix the problem and update the map distro. Thanks.", vbCritical
           DrwDosMap = ""
           On Error GoTo 0
End Function

